--- chan_zap.c	2005-09-12 00:38:59.000000000 +0100
+++ chan_zap.c.faris	2005-09-12 00:37:36.000000000 +0100
@@ -4098,28 +4098,32 @@
 			if (p->polarity == POLARITY_IDLE) {
 				p->polarity = POLARITY_REV;
 				if (p->answeronpolarityswitch &&
-				    ((ast->_state == AST_STATE_DIALING) ||
-				     (ast->_state == AST_STATE_RINGING))) {
+				    ( (ast->_state == AST_STATE_DIALING) ||
+				     (ast->_state == AST_STATE_RINGING) || (ast->_state == AST_STATE_RING) ) ) {
 					ast_log(LOG_DEBUG, "Answering on polarity switch!\n");
 					ast_setstate(p->owner, AST_STATE_UP);
-				} else 
-					ast_log(LOG_DEBUG, "Ignore switch to REVERSED Polarity on channel %d, state %d\n", p->channel, ast->_state);
-			} else if(p->hanguponpolarityswitch &&
+				} else
+          			  ast_log(LOG_DEBUG, "Polarity Reversal IGNORED on channel %d, state %d, pol= %d, aonp= %d, honp= %d, pdelay= %d, tv= %d\n", p->channel, ast->_state, p->polarity, p->answeronpolarityswitch, p->hanguponpolarityswitch, p->polarityonanswerdelay, ast_tvdiff_ms(ast_tvnow(), p->polaritydelaytv) );
+			} 
+			/* removed else from here and basically added AST_STATE_RING to both the above and the below sections. Also added additinal debug output */
+			if(p->hanguponpolarityswitch &&
 				(p->polarityonanswerdelay > 0) &&
-			        (p->polarity == POLARITY_REV) &&
-				(ast->_state == AST_STATE_UP)) {
-
+			       (p->polarity == POLARITY_REV) &&
+				((ast->_state == AST_STATE_UP) || (ast->_state == AST_STATE_RING)) ) {
+				ast_log(LOG_DEBUG, "DEBUG 1: channel %d, state %d, pol= %d, aonp= %d, honp= %d, pdelay= %d, tv= %d\n", p->channel, ast->_state, p->polarity, p->answeronpolarityswitch, p->hanguponpolarityswitch, p->polarityonanswerdelay, ast_tvdiff_ms(ast_tvnow(), p->polaritydelaytv) );
+			
 				if(ast_tvdiff_ms(ast_tvnow(), p->polaritydelaytv) > p->polarityonanswerdelay) {
-					ast_log(LOG_DEBUG, "Hangup due to Reverse Polarity on channel %d\n", p->channel);
+					ast_log(LOG_DEBUG, "Polarity Reversal detected and now Hanging up on channel %d\n", p->channel);
 					ast_softhangup(p->owner, AST_SOFTHANGUP_EXPLICIT);
 					p->polarity = POLARITY_IDLE;
 				} else {
-					ast_log(LOG_DEBUG, "Ignore Reverse Polarity (too close to answer event) on channel %d, state %d\n", p->channel, ast->_state);
+					ast_log(LOG_DEBUG, "Polarity Reversal detected but NOT hanging up (too close to answer event) on channel %d, state %d\n", p->channel, ast->_state);
 				}
 			} else {
 				p->polarity = POLARITY_IDLE;
-				ast_log(LOG_DEBUG, "Ignore switch to IDLE Polarity on channel %d, state %d\n", p->channel, ast->_state);
+				ast_log(LOG_DEBUG, "Ignoring Polarity switch to IDLE on channel %d, state %d\n", p->channel, ast->_state);
 			}
+                     ast_log(LOG_DEBUG, "DEBUG 2: channel %d, state %d, pol= %d, aonp= %d, honp= %d, pdelay= %d, tv= %d\n", p->channel, ast->_state, p->polarity, p->answeronpolarityswitch, p->hanguponpolarityswitch, p->polarityonanswerdelay, ast_tvdiff_ms(ast_tvnow(), p->polaritydelaytv) );
 			break;
 		default:
 			ast_log(LOG_DEBUG, "Dunno what to do with event %d on channel %d\n", res, p->channel);
@@ -4129,6 +4133,7 @@
 
 
 
+
 static struct ast_frame *__zt_exception(struct ast_channel *ast)
 {
 	struct zt_pvt *p = ast->tech_pvt;
